/*
 **	\file zd.c
 **	\date  2006-04-20
 **	\author grymse@alhem.net
**/
/*
Copyright (C) 2006  Anders Hedstrom

This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2
of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
*/
#include <stdio.h>
#include <string.h>
#include <ctype.h>
#include <stdlib.h>


int main(int argc,char *argv[])
{
	FILE *fil;
	unsigned char c;
	char slask[200];
	int i;
	long addr = 0;

	if (argc < 2)
	{
		printf("Usage: %s <file>\n",*argv);
		exit(-1);
	}
	if ((fil = fopen(argv[1],"rb")) != NULL)
	{
		while (!feof(fil))
		{
			printf("%04lx ",addr);
			*slask = 0;
			for (i = 0; i < 16; i++)
			{
				fread(&c,1,1,fil);
				printf(" %02x",c);
				if (isprint(c & 0x7f))
					sprintf(slask + strlen(slask),"%c",c & 0x7f);
				else
					strcat(slask,".");
				if (i == 7)
				{
					printf(" ");
					strcat(slask," ");
				}
			}
			printf("  %s\n",slask);
			addr += 16;
		}
		fclose(fil);
	} else
		printf("Couldn't open '%s'...\n",argv[1]);
	return 0;
}
